/*
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   ### File Specific:
   main-programmer: Patrick Boenzli
   co-programmer: ...
*/


/* this is for debug output. It just says, that all calls to PRINT() belong to the DEBUG_MODULE_NETWORK module
   For more information refere to https://www.orxonox.net/cgi-bin/trac.cgi/wiki/DebugOutput
*/
#define DEBUG_MODULE_NETWORK


#include "network_stream.h"
#include "list.h"


/* include your own header */
#include "network_manager.h"

/* include this file, it contains some default definitions */
#include "netdefs.h"

/* using namespace std is default, this needs to be here */
using namespace std;


/************************************
  What you will see here are the function definitions from the header file (network_manager.h) with doxygen documentation. Here is an example:


 In file network_manager.h

 class NetworkManager
 {
   int doSomeStuff(float argument, float* pointer);
 }

 will be implemented in the source file as follows:

 In file network_manager.cc

 / **
  *  this is the short description for this function: it just does some stuff
  * @param argument: this is the first argument, stuff...
  * @param pointer:  this is the pointer to nowhereland
  * return: whatever the function returns: for example an index, number, etc.
  * /
 int NetworkManager::doSomeStuff(float argument, float* pointer)
 {
   // whaterver you want to do
 }


 if you want to make automake compile your files: you will want to add the file names to the local Makefile.am

 ************************************/


/**
 *  standard constructor
 */
NetworkManager::NetworkManager()
{
  this->netStreamList = new tList<NetworkStream>();
  NetworkStream* ns = new NetworkStream();
}


/**
 *  standard deconstructor
 */
NetworkManager::~NetworkManager()
{}


/**
 *  initializes the network manager
 */
void NetworkManager::initialize()
{}


/**
 *  shutsdown the network manager
 */
void NetworkManager::shutdown()
{}


/**
 *  creates a connection from one object to a host
 * @param address: the address of the destination host
 * @param synchronizeable: reference to the sync object
 */
void NetworkManager::establishConnection(/* address, port, object reference*/)
{}


/**
 *  teardown a connection
 */
void NetworkManager::shutdownConnection()
{}


/**
 *  registers a listener at the network manager
 * @param listener: the reference to the listener to be added
 */
void NetworkManager::registerListener(/* listener reference*/)
{}

/**
 *  sync the network
 */
void NetworkManager::synchronize()
{}


